## -*- coding: utf-8; -*-

<script type="text/x-template" id="${grid.vue_tagname}-template">
  <${b}-table :data="data"
              :loading="loading"

              narrowed
              hoverable
              icon-pack="fas"

              ## paging
              % if grid.paginated:
                  paginated
                  pagination-size="is-small"
                  :per-page="perPage"
                  :current-page="currentPage"
              % endif
              >

    % for column in grid.get_vue_columns():
        <${b}-table-column field="${column['field']}"
                           label="${column['label']}"
                           v-slot="props"
                           cell-class="c_${column['field']}">
          % if grid.is_linked(column['field']):
              <a :href="props.row._action_url_view"
                 v-html="props.row.${column['field']}" />
          % else:
              <span v-html="props.row.${column['field']}"></span>
          % endif
        </${b}-table-column>
    % endfor

    % if grid.actions:
        <${b}-table-column field="actions"
                           label="Actions"
                           v-slot="props">
          % for action in grid.actions:
              <a v-if="props.row._action_url_${action.key}"
                 :href="props.row._action_url_${action.key}"
                 class="${action.link_class}">
                ${action.render_icon_and_label()}
              </a>
              &nbsp;
          % endfor
        </${b}-table-column>
    % endif

    % if grid.paginated:
        <template #footer>
          <div style="display: flex; justify-content: space-between;">
            <div></div>
            <div style="display: flex; gap: 0.5rem; align-items: center;">
              <span>
                showing
              </span>
              <b-select v-model="perPage"
                        size="is-small">
                <option v-for="size in pageSizeOptions"
                        :value="size">
                  {{ size }}
                </option>
              </b-select>
              <span>
                per page
              </span>
            </div>
          </div>
        </template>
      % endif

  </${b}-table>
</script>

<script>

  const ${grid.vue_component}CurrentData = ${json.dumps(grid.get_vue_data())|n}

  const ${grid.vue_component}Data = {
      data: ${grid.vue_component}CurrentData,
      loading: false,

      ## paging
      % if grid.paginated:
          pageSizeOptions: ${json.dumps(grid.pagesize_options)|n},
          perPage: ${json.dumps(grid.pagesize)|n},
          currentPage: ${json.dumps(grid.page)|n},
      % endif
  }

  const ${grid.vue_component} = {
      template: '#${grid.vue_tagname}-template',
      methods: {},
  }

</script>
